import { Component, OnInit } from '@angular/core';
import { ContactService } from '../contact.service';
import { Router } from '@angular/router'; // tarvitaan navigateToList() -metodia varten

import { Contact } from '../contact';

@Component({
  selector: 'app-contactnew',
  templateUrl: './contactnew.component.html',
  styleUrls: ['./contactnew.component.css']
})
export class ContactnewComponent implements OnInit {

  constructor(private contactService: ContactService, private router: Router) {}

  ngOnInit() {}

  // kontakti serverille
  onSubmit(formData: any, isFormValid: boolean | null) {
    console.log(formData);
    /*contactservicen postausmetodia käytetään. Subscribe -metodi
    pitää olla perässä jotta lähetys onnistuisi vaikka emme tässä
    tapauksessa "tilaa" mitään dataa jonka observable toimittaisi.
    */
    if (isFormValid) { // lomakedata menee serverille vain jos isFormValid on true
      this.contactService.postContactToServer(
        {
          'name': formData.name,
          'email': formData.email
      // subscribe on välttämätön jotta servicen metodi suoritetaan
      // as Contact tarkoittaa että kyseessä on Contact-tyyppisen datan lähetys 
      // Data voidaan lähettää ilman Contact-tyyppiin kuuluvaa id:tä joka generoidaan kannassa 
        } as Contact).subscribe();
      // Siirrytään listaan kun data on lähetetty serverille
      this.navigateToList()

    }
  }

  navigateToList() {
    this.router.navigate(['/']);
  }

}
